require "defines"

function glob_init()

    global['stand-still'] = global['stand-still'] or {}

end

function seek_exit(ax, ay, bx, by, cx, cy, dir)

    local ents = game.get_surface(1).find_entities_filtered{ area = {{ ax, ay }, { bx, by }}, name = "player-tunnel" }

    if #ents == 0 then
        return nil
    end

    local i = 0
    local distance = 0
    local mindistance = 99999
    local exit = nil

    for i = 1, #ents do

        if ents[i].direction == dir then
            distance = (ents[i].position.x - cx) * (ents[i].position.x - cx) + (ents[i].position.y - cy) * (ents[i].position.y - cy)
            if distance < mindistance then
                exit = ents[i]
                mindistance = distance
            end
        end

    end

    return exit

end

function process_tunnels(player)

    local posx = player.position.x
    local posy = player.position.y

    local ents = game.get_surface(1).find_entities_filtered{ area = {{ posx - 0.5, posy - 0.5}, {posx + 0.5, posy + 0.5}}, name = "player-tunnel"}

    if #ents == 0 then
        return
    end

    local i = 0
    local exit = nil

    for i = 1, #ents do

        local eposx = ents[i].position.x
        local eposy = ents[i].position.y
        local dir = ents[i].direction

        if dir == defines.direction.north and posx > eposx - 0.5 and posx < eposx + 0.5 and posy > eposy then
            exit = seek_exit(eposx - 0.1, eposy - 7.0, eposx + 0.1, eposy - 2.0, eposx, eposy, defines.direction.south)
        elseif dir == defines.direction.east and posy > eposy - 0.5 and posy < eposy + 0.5 and posx < eposx then
            exit = seek_exit(eposx + 2.0, eposy - 0.1, eposx + 7.0, eposy + 0.1, eposx, eposy, defines.direction.west)
        elseif dir == defines.direction.south and posx > eposx - 0.5 and posx < eposx + 0.5 and posy < eposy then
            exit = seek_exit(eposx - 0.1, eposy + 2.0, eposx + 0.1, eposy + 7.0, eposx, eposy, defines.direction.north)
        elseif dir == defines.direction.west and posy > eposy - 0.5 and posy < eposy + 0.5 and posx > eposx then
            exit = seek_exit(eposx - 7.0, eposy - 0.1, eposx - 2.0, eposy + 0.1, eposx, eposy, defines.direction.east)
        end

    end

    if exit then

        if exit.direction == defines.direction.north then
            player.teleport{ x = exit.position.x, y = exit.position.y + 1.5}
        elseif exit.direction == defines.direction.east then
            player.teleport{ x = exit.position.x - 1.5, y = exit.position.y}
        elseif exit.direction == defines.direction.south then
            player.teleport{ x = exit.position.x, y = exit.position.y - 1.5}
        elseif exit.direction == defines.direction.west then
            player.teleport{ x = exit.position.x + 1.5, y = exit.position.y}
        end

    end

end

script.on_event(defines.events.on_tick, function(event)

    local i = 0
    local player = nil
    local oldx = 0
    local oldy = 0
    local ticks = 0

    if event.tick % 20 == 0 then
         for i = 1, #game.players do

             player = game.players[i]

             if not global['stand-still'][player.name] then
                 global['stand-still'][player.name] = {}
                 global['stand-still'][player.name]['x'] = 0
                 global['stand-still'][player.name]['y'] = 0
                 global['stand-still'][player.name]['n'] = 0
             end

             oldx = global['stand-still'][player.name]['x']
             oldy = global['stand-still'][player.name]['y']
             ticks = global['stand-still'][player.name]['n']

             if player.position.x == oldx and player.position.y == oldy then
                 ticks = ticks + 1
             else
                 ticks = 0
             end

             global['stand-still'][player.name]['x'] = player.position.x
             global['stand-still'][player.name]['y'] = player.position.y
             global['stand-still'][player.name]['n'] = ticks

             if ticks > 5 then
                 process_tunnels(player)
             end

         end
    end

end)

script.on_init(function()

    glob_init()

end)

script.on_load(function()

    glob_init()

end)

